config/routes.rb
Rails.application.routes.draw do  
  mount Ckeditor::Engine => '/ckeditor'
  devise_for :admins
  mount RailsAdmin::Engine => '/admin', as: 'rails_admin'
  # Added devise routes and overrided registration controller
  devise_for :users, :controllers => { registrations: 'registrations' }
  # hotel resources only with index route
  resources :hotel, only: :index do
    get :rooms, on: :collection
  end
  get '/remove/:id', to: 'bookings#remove', as: 'remove'
  
  # test paypal
  resources :payments
  post "/hook" => "payments#hook"
  post "/payments/:id" => "payments#show"


  # Listing our all the bookings of the user
  resources :bookings, only: [:index, :edit, :destroy ]
  resources :services, only: :index
  get "dining", to: "hotel#foods", as: :dining  

  # Using resource hotel_categories for using the hotel_category_id for nested resources
  resources :hotel_categories, only: [] do
    # Using booking resources
    resources :bookings, only: [:new, :create] do 
      collection do
        get :search_rooms
        # route for checkig available_rooms
        get :available_rooms
      end
    end
  end

  # api routes
  namespace :api, defaults: {format: :json} do
    namespace :v1 do
      devise_for :users
      resources :hotel_rooms, only: :index
      resources :booking_informations, only: :index
    end
  end

  # root path 
  root "hotel#index"
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html



end

app/models/booking.rb
# == Schema Info
#
# Table name: bookings
#
# id                         :integer(11), not null, primary key
# check_in                   :date
# check_out                  :date
# hotel_room_id              :integer(11)
# purchased_at               :integer(11)
# user_id                    :integer(11)
# created_at                 :datetime, not null
# updated_at                 :datetime, not null

class Booking < ApplicationRecord
  # including validation methods
  include BookingValidations
  # callback to save booking dates with in booking dates table
  after_save :create_or_update_booking_dates
  # adding belongs to relationship with hotel_room
  belongs_to :hotel_room
  # adding belongs to relationship with user
  belongs_to :user
  # added has_many relationship with booking_dates
  has_many :booking_dates, dependent: :destroy
  has_one :payment

  # These attributes should always be present
  validates :check_in, :check_out, :hotel_room_id, :user_id, presence: true

  # Custom valudation for check in date
  # Check in date cannot be in the past
  validate :check_in_cannot_be_in_the_past

  # Custom valudation for check out date
  # Check out date should not be less than check in date
  validate :check_out_should_be_less_than_check_in

  # Custom Validation for limiting the booking for 6 months
  # Allows booking up to 6 months in advance for room reservations
  validate :check_out_cannot_be_more_than_6_months

  # Checking the hotel room availability
  validate :room_availability_check
end

app/controllers/bookings_controller.rb
class BookingsController < ApplicationController
  before_action :authenticate_user!
  before_action :check_time, :set_total
  before_action :set_hotel_category, only: [:new, :create, :available_rooms, :search_rooms]

  def new
  end

  def create
    @booking = current_user.bookings.new(booking_params)
    @condition = false
    hotel_room = HotelRoom.find_by(id: booking_params[:hotel_room_id])
    hotel_room.update(status: true)
    
    if @booking.save 
      @bookings = current_user.bookings.order(created_at: :desc).last
      BookingMailer.send_receipt(@bookings, @bookings.user.email).deliver_now
      @condition = true
    end
  end

  def edit
    @bookings = Booking.find_by(id: params[:id] )
    @booking_details = @bookings.hotel_room.hotel_category

  end

  def destroy
    @order = Booking.find(params[:id])
    @order.hotel_room.update(status: false)
    BookingMailer.send_destroy(@order, @order.user.email).deliver_now
    @order.destroy
    redirect_to bookings_path, notice: 'Your booking has been cancelled!'
  end

  def index
    @bookings = current_user.bookings.order(created_at: :desc )
  end

  # Method for available rooms view
  def available_rooms
    @booking = current_user.bookings.new(booking_params)
    @hotel_rooms = @hotel_category.hotel_rooms.available_rooms(params[:booking][:check_in], params[:booking][:check_out])
  end

  # Method for search rooms view
  def search_rooms
  end

  def remove
    booking = Booking.find_by(id: params[:id])
    booking.destroy
    redirect_to bookings_path, notice: 'Your booking has been removed!'
  end

  private

  def set_hotel_category
    @hotel_category = HotelCategory.find(params[:hotel_category_id])
  end

  def booking_params
    params.require(:booking).permit(:check_in, :check_out, :hotel_room_id)
  end

  def set_total
    all_booking = Booking.all
    all_booking.each do |booking|
      booking_details = booking.hotel_room.hotel_category
      sub = booking_details.price
      stay_time = booking.booking_dates.size
      tax = (sub*stay_time*10/100)
      total = (sub*stay_time+tax)
      booking.update_attribute(:total_amount_cents, total)
    end
  end

  def check_time
    all_booking = Booking.all
    all_booking.each do |booking|
      time = booking.created_at.to_i + (2*60*60)
      now = Time.now.to_i
      if time - now < 0
        booking.hotel_room.update(status: false)
        booking.booking_dates.each do |booking_date|
          booking_date.destroy
        end
      end
    end
  end
end

app/helpers/bookings_helper.rb
module BookingsHelper
end

app/views/bookings/_available_rooms.html.erb
<section id="reservation-form" class="mt50 clearfix">
    <div class="col-sm-12 col-md-4">
        <%= form_for(@booking, as: :booking, url: hotel_category_bookings_path(@hotel_category), html: {class: "reservation-vertical clearfix", remote: true}) do |f| %>
            <h2 class="lined-heading"><span>Reservation</span></h2>
            <div class="price">
                <h4><%= @hotel_category.name %></h4><br/>
                &#x20B9; <%= @hotel_category.price%>,-<span> a night</span></div>
                <div id="message"></div>
                <%= f.text_field :check_in, class: "hidden" %>
                <%= f.text_field :check_out, class: "hidden"  %>
            <div class="form-group">
                <%= f.select :hotel_room_id, @hotel_rooms.all.collect { |p| [ "Room #{p.name}", p.id ] }, {prompt: "Select Room"}, {class: "form-control"} %>      
            </div>
            <button type="submit" class="btn btn-primary btn-block">Book Now</button>
            <br/>
            <%= link_to search_rooms_hotel_category_bookings_path(@hotel_category), remote: true do %>
                < Go back and select new date range
            <% end %>
        <% end %>
    </div>
</section>

app/views/bookings/_order_summary.html.erb
<div class="order-summary">
    <div class="row">
        <div class="col-xs-12">
            <p >
               <h3 style="text-align: center !important;"> <em><%= @booking_details.name %></em></h3>
            </p>
            <div class="row">
                <div class="col-xs-12 col-xs-offset-1 col-sm-offset-3 col-md-offset-3 col-lg-offset-3">
                    <p>
                        <%=image_tag @booking_details.image%>
                    </p>
                </div>
            </div>
        </div>
    </div>
    <hr />
    <div class="row">
        <div class="col-xs-12 text-right">
            <% sub = @booking_details.price%>
            <% stay_time = @bookings.booking_dates.count%>
            <% tax = (sub*stay_time*10/100)%>
            <h4>
                <p> <strong>Check in:</strong>  <%= @bookings.check_in.strftime("%a, %d-%B, %Y") %></p>
                <p> <strong>Check out:</strong>  <%=  @bookings.check_out.strftime("%a, %d-%B, %Y") %></p>
                <p> <strong>Night(s):</strong> <%= stay_time %></p>
                <p><strong> Subtotal:</strong> <%= "$" + sub.to_s + "/night"  %> </p>
                <p><strong>Tax:</strong> <%= tax.to_s + "$"%></p>
                <p><strong>Total: <%= (sub*stay_time+tax).to_s + "$"%></strong></p>
            </h4>
        </div>
    </div>
</div>

app/views/bookings/_pay_form.html.erb
<form class="credit-card">
    <div class="form-header">
        <h4 class="title">Credit card detail</h4>
    </div>

    <div class="form-body">
        <!-- Card Number -->
        <input type="text" class="card-number" placeholder="Card Number">

        <!-- Date Field -->
        <div class="date-field">
            <div class="month">
                <select name="Month">
                    <option value="january">January</option>
                    <option value="february">February</option>
                    <option value="march">March</option>
                    <option value="april">April</option>
                    <option value="may">May</option>
                    <option value="june">June</option>
                    <option value="july">July</option>
                    <option value="august">August</option>
                    <option value="september">September</option>
                    <option value="october">October</option>
                    <option value="november">November</option>
                    <option value="december">December</option>
                </select>
            </div>
            <div class="year">
                <select name="Year">
                    <option value="2016">2016</option>
                    <option value="2017">2017</option>
                    <option value="2018">2018</option>
                    <option value="2019">2019</option>
                    <option value="2020">2020</option>
                    <option value="2021">2021</option>
                    <option value="2022">2022</option>
                    <option value="2023">2023</option>
                    <option value="2024">2024</option>
                </select>
            </div>
        </div>

        <!-- Card Verification Field -->
        <div class="card-verification">
            <div class="cvv-input">
                <input type="text" placeholder="CVV">
            </div>
            <div class="cvv-details">
                <p>3 digits usually found <br> on the signature strip</p>
            </div>
        </div>

        <!-- Buttons -->
        <button type="submit" class="proceed-btn"><a href="#">Proceed</a></button>

        
    </div>
</form>

app/views/bookings/_search_rooms.html.erb
<section id="reservation-form" class="mt50 clearfix" style="background-color: #FFFF99 ">
    <div class="col-sm-12 col-md-4">
        <%= form_tag available_rooms_hotel_category_bookings_path(@hotel_category), method: :get, class:"reservation-vertical clearfix", remote: true do %>
            <h2 class="lined-heading"><span>Reservation</span></h2>
            <div class="price">
            <h4><%= @hotel_category.name %></h4><br/>
            $ <%= @hotel_category.price%><span>/ a night</span></div>
            <div id="message"></div>
            <!-- Error message display -->
                <div class="form-group">
                    <label for="checkin">Check-in</label>
                    <div class="popover-icon" data-container="body" data-toggle="popover" data-trigger="hover" data-placement="right" data-content="Check-In is from 11:00"> 
                        <i class="fa fa-info-circle fa-lg"> </i> 
                    </div>
                    <i class="fa fa-calendar infield"></i>
                    <input name="booking[check_in]" type="text" id="checkin" value="" class="form-control" placeholder="Check-in"/>
                </div>
            <div class="form-group">
                <label for="checkout">Check-out</label>
                <div class="popover-icon" data-container="body" data-toggle="popover" data-trigger="hover" data-placement="right" data-content="Check-out is from 12:00"> 
                    <i class="fa fa-info-circle fa-lg"> </i> 
                </div>
                <i class="fa fa-calendar infield"></i>
                <input name="booking[check_out]" type="text" id="checkout" value="" class="form-control" placeholder="Check-out"/>
            </div>
            <button type="submit" class="btn btn-warning btn-block">Search Rooms</button>
        <% end %>
    </div>
</section>

app/views/bookings/_successfully_booked.html.erb
<section id="reservation-form" class="mt50 clearfix">
    <div class="col-sm-12 col-md-4">
        <h2 class="lined-heading"><span>Reservation</span></h2>
        <div class="price">
            <h4><%= @hotel_category.name %></h4><br/>
            &#x20B9; <%= @hotel_category.price%>-<span> a night</span></div>
        <div id="message"></div>
        <h3><i>Room <%= @booking.hotel_room.name %> has been successfully booked by you from <%= @booking.check_in.to_date %> to <%= @booking.check_out.to_date %></i></h3>

        <%= link_to bookings_path do %>
            <button type="button" class="btn btn-primary btn-block">My Bookings</button>
        <% end %>
        <br/>
        <%= link_to search_rooms_hotel_category_bookings_path(@hotel_category), remote: true do %>
            < Go back and book a new room
        <% end %>
    </div>
</section>

app/views/bookings/available_rooms.js.erb
// Validations for search filters of rooms
<% @booking.valid? %>
<% error_messages = @booking.errors.messages.slice(:check_in, :check_out) %>
<% if !error_messages.blank? %>
    errors = ""
	$.each(<%= raw error_messages.to_json %>, function(k, v) {
        $(v).each(function(){
            errors+="<li><span class='red-validation'><span class='capitalize red-validation'>"+k.replace(/_/g,' ')+"</span> "+this+"</span></li>"
        })
    });  
    $("#message").html(errors)
<% elsif @hotel_rooms.blank? %>
    $("#message").html("<span class='red-validation'>No Rooms are available in this date range.</span>")
<% else %>
    $("#message").empty()
    $("#reservation-form").replaceWith("<%= j( render 'available_rooms' )%>")
<% end %>

app/views/bookings/create.js.erb
// Validations for search filters of rooms
<% if @condition = true %>
	$("#message").empty()
	$("#reservation-form").replaceWith("<%= j( render 'successfully_booked' )%>")
	
<% else %>
	errors = ""
	$.each(<%= raw @booking.errors.to_json %>, function(k, v) {
        $(v).each(function(){
            errors+="<li><span class='red-validation'><span class='capitalize red-validation'>"+k.replace(/_/g,' ')+"</span> "+this+"</span></li>"
        })
    });  
    $("#message").html(errors)
<% end %>

app/views/bookings/index.html.erb
<!-- Parallax Effect -->
<script type="text/javascript">$(document).ready(function(){$('#parallax-pagetitle').parallax("50%", -0.55);});</script>
<section class="parallax-effect">
    <div id="parallax-pagetitle" style="background-image: url(/assets/parallax/parallax-01.jpg);">
        <div class="color-overlay"> 
            <!-- Page title -->
            <div class="container">
                <div class="row">
                    <div class="col-sm-12">
                        <ol class="breadcrumb">
                            <li><a href="/">Home</a></li>
                            <li class="active">My Bookings</li>
                        </ol>
                        <h1>My Bookings</h1>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>

<!-- Rooms -->
<section class="rooms mt100">
    <div class="container">
        <div class="row room-list fadeIn appear"> 
            <% if !@bookings.blank? %>
                <% @bookings.each do |booking| %>
                <!-- Room -->
                <!-- Check to destroy booking when time out to pay -->
                    <div class="col-sm-4 category_<%= booking.hotel_room.hotel_category.id%>" >
                        <div class="top-of-image">
                            <p><span>From <%= booking.check_in.strftime("%d-%m-%Y") %> to <%= booking.check_out.strftime("%d-%m-%Y") %></span></p>
                            <% ngay =  booking.created_at.to_i%>
                            <% time_booking = ngay + (2*60*60*1000)%>
                            <% now = Time.now.to_i%>
                            <button class="btn btn-info btn-block countDown" id="demo<%=booking.id%>" style="background-color: Black; color: #FF9900" onclick="createCountDown(<%=booking.id%>, <%=ngay%>)">
                                Check Room Status
                            </button>
                            <%= link_to "Pay booking", edit_booking_path(booking.id), class: "btn btn-warning btn-block hidden", id: "pay_btn#{booking.id}"%>
                            <%= link_to "Cancel booking", booking_path(booking.id), id: "destroy_btn#{booking.id}", method: :delete, data: { confirm: 'Are you sure you want to cancel this booking?' }, class: "btn btn-danger btn-block hidden" %>
                            <%= link_to "Remove From List", remove_path(booking.id), id: "remove_btn#{booking.id}", class: "btn btn-danger btn-block hidden" %>
                            <%= javascript_tag do %>
                                function createCountDown(id, ngay) {
                                    // Set the date we're counting down to
                                    var countDownDate = ngay*1000 + (2*60*60*1000);    
                                    

                                    // Update the count down every 1 second
                                    var x = setInterval(function() {

                                        // Get todays date and time
                                       
                                        var now = new Date().getTime();
                                        // Find the distance between now and the count down date
                                        var distance = countDownDate - now;

                                        // Time calculations for days, hours, minutes and seconds
                                        var days = Math.floor(distance / (1000 * 60 * 60 *   24));
                                        var hours = Math.floor((distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
                                        var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
                                        var seconds = Math.floor((distance % (1000 * 60)) / 1000);

                                        // Output the result in an element with id="demo"
                                        document.getElementById('demo'+id).innerHTML = hours + "h "
                                        + minutes + "m " + seconds + "s ";

                                        if (distance > 0) {
                                            clearInterval(x);
                                            removeClass(id);
                                        }
                                        else{
                                            clearInterval(x);
                                            document.getElementById('demo'+id).innerHTML = "Time out to pay"  ;
                                            document.getElementById('remove_btn'+id).classList.remove("hidden");
                                        }
                                    }, 1000); 
                                };
                                function removeClass(id){
                                    document.getElementById('pay_btn'+id).classList.remove("hidden");
                                    document.getElementById('destroy_btn'+id).classList.remove("hidden");
                                }
                            <% end %>
                        </div>
                        <div class="room-thumb"> 
                            <%= image_tag booking.hotel_room.hotel_category.image, class: "img-responsive" %>
                            <div class="mask">
                                <div class="main">
                                    <h5><%= booking.hotel_room.hotel_category.name %>, <i>Room: <%= booking.hotel_room.name %></i></h5>
                                    <div class="price">&#x20B9; <%= booking.hotel_room.hotel_category.price %>
                                        <span>a night</span>
                                    </div>
                                </div>
                                <div class="content">
                                    <p><%= booking.hotel_room.hotel_category.title.html_safe%></p>
                                    <div class="row">
                                        <div class="col-xs-6">
                                            <ul class="list-unstyled">
                                                <li><i class="fa fa-check-circle"></i> Incl. breakfast</li>
                                                <li><i class="fa fa-check-circle"></i> Private balcony</li>
                                                <li><i class="fa fa-check-circle"></i> Sea view</li>
                                            </ul>
                                        </div>
                                        <div class="col-xs-6">
                                            <ul class="list-unstyled">
                                                <li><i class="fa fa-check-circle"></i> Free Wi-Fi</li>
                                                <li><i class="fa fa-check-circle"></i> Incl. breakfast</li>
                                                <li><i class="fa fa-check-circle"></i> Bathroom</li>
                                            </ul>
                                        </div>
                                    </div>
                                    <br/>
                                    <b><i>Booked by you</i></b> 
                                </div>
                            </div>
                        </div>
                    </div>
                <% end %>
            <% else %>
                <h2>No Bookings by you.</h2>
            <% end %>
        </div>
    </div>
</section>

app/views/bookings/new.html.erb
<!-- Parallax Effect -->
<script type="text/javascript">$(document).ready(function(){$('#parallax-pagetitle').parallax("50%", -0.55);});</script>
<section class="parallax-effect">
    <div id="parallax-pagetitle" style="background-image: url(/assets/parallax/parallax-01.jpg);">
        <div class="color-overlay"> 
            <!-- Page title -->
            <div class="container">
                <div class="row">
                    <div class="col-sm-12">
                        <ol class="breadcrumb">
                            <li><a href="/">Home</a></li>
                            <li><a href="#">Room list view</a></li>
                            <li class="active">Room detail</li>
                        </ol>
                        <h1><%= @hotel_category.name%></h1>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>
<div class="container">
    <div class="row"> 
        <!-- Slider -->
        <section class="room-slider standard-slider mt50">
            <div class="col-sm-12 col-md-8">
                <div id="owl-standard" class="owl-carousel">
                    <div class="item"> <a href="/assets/rooms/slider/room-slider-02.jpg" data-rel="prettyPhoto[gallery1]"><img src="/assets/rooms/slider/room-slider-02.jpg" alt="Bed" class="img-responsive"></a> </div>
                    <div class="item"> <a href="/assets/rooms/slider/room-slider-03.jpg" data-rel="prettyPhoto[gallery1]"><img src="/assets/rooms/slider/room-slider-03.jpg" alt="Bathroom" class="img-responsive"></a> </div>
                </div>
            </div>
        </section>
    
    <!-- Reservation form -->
    <%= render 'search_rooms' %>
    
    <!-- Room Content -->
        <section>
            <div class="container">
                <div class="row">
                    <div class="col-sm-7 mt50">
                        <h2 class="lined-heading"><span>Room Details</span></h2>
                        <h3 class="mt50">Table overview</h3>
                        <table class="table table-striped mt30">
                            <tbody>
                                <tr>
                                    <td><i class="fa fa-check-circle"></i> Double Bed</td>
                                    <td><i class="fa fa-check-circle"></i> Free Internet</td>
                                    <td><i class="fa fa-check-circle"></i> Free Newspaper</td>
                                </tr>
                                <tr>
                                    <td><i class="fa fa-check-circle"></i> 60 square meter</td>
                                    <td><i class="fa fa-check-circle"></i> Beach view</td>
                                    <td><i class="fa fa-check-circle"></i> 2 persons</td>
                                </tr>
                                <tr>
                                    <td><i class="fa fa-check-circle"></i> Double Bed</td>
                                    <td><i class="fa fa-check-circle"></i> Free Internet</td>
                                    <td><i class="fa fa-check-circle"></i> Breakfast included</td>
                                </tr>
                                <tr>
                                    <td><i class="fa fa-check-circle"></i> Private Balcony</td>
                                    <td><i class="fa fa-check-circle"></i> Flat Screen TV</td>
                                    <td><i class="fa fa-check-circle"></i> Jacuzzi</td>
                                </tr>
                            </tbody> 
                        </table>
                    </div>
                    <div class="col-sm-5 mt50">
                        <h2 class="lined-heading"><span>Overview</span></h2>

                        <!-- Nav tabs -->
                        <ul class="nav nav-tabs">
                            <li class="active"><a href="#overview" data-toggle="tab">Overview</a></li>
                        </ul>
                        <!-- Tab panes -->
                        <div class="tab-content">
                            <div class="tab-pane fade in active" id="overview">
                                <p>KP Home offers the guests an unforgettable stay with warm hospitality, unique service quality in the magical nature of mediterranean. With 462 rooms capacity, beachfront location and most importantly with his very friendly service was placed in the short time in hearts of many guests.</p>
                                <p><img src="/assets/tab/restaurant-01.jpg" alt="food" class="pull-right"> Unlimited hospitality and perfect service awaits you from the moment you step in our Hotel. Full 12 months 'All Inclusive' accommodation at your service.
                                Our rooms which have great views have all the comforts that our guests may need. Due to the different expectations, different types of rooms were designed like suites, deluxe rooms and standard rooms. </p>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </section>
    </div>
</div>

<!-- Other Rooms -->
<section class="rooms mt50">
    <div class="container">
        <div class="row">
            <div class="col-sm-12">
                <h2 class="lined-heading"><span>Other rooms</span></h2>
            </div>
            <% HotelCategory.take(3).each do |hotel_category| %>
                <!-- Room -->
                <div class="col-sm-4">
                    <div class="room-thumb"> <img src="/assets/rooms/room-01.jpg" alt="room 1" class="img-responsive" />
                        <div class="mask">
                            <div class="main">
                                <h5><%= hotel_category.name %></h5>
                                <div class="price">&#x20B9; <%= hotel_category.price %><span>a night</span></div>
                            </div>
                        <div class="content">
                            <p><span>A modern hotel room in Star Hotel</span> Nunc tempor erat in magna pulvinar fermentum. Pellentesque scelerisque at leo nec vestibulum. 
                            malesuada metus.</p>
                            <div class="row">
                                <div class="col-xs-6">
                                    <ul class="list-unstyled">
                                        <li><i class="fa fa-check-circle"></i> Incl. breakfast</li>
                                        <li><i class="fa fa-check-circle"></i> Private balcony</li>
                                        <li><i class="fa fa-check-circle"></i> Sea view</li>
                                    </ul>
                                </div>
                                <div class="col-xs-6">
                                    <ul class="list-unstyled">
                                        <li><i class="fa fa-check-circle"></i> Free Wi-Fi</li>
                                        <li><i class="fa fa-check-circle"></i> Incl. breakfast</li>
                                        <li><i class="fa fa-check-circle"></i> Bathroom</li>
                                    </ul>
                                </div>
                            </div>
                            <a href="<%= new_hotel_category_booking_path(hotel_category) %>" class="btn btn-primary btn-block">Book Now</a> </div>
                        </div>
                    </div>
                </div>
            <% end %>
        </div>
    </div>
</section>

app/views/bookings/search_rooms.js.erb
 $("#reservation-form").replaceWith("<%= j( render 'search_rooms' )%>")
// Reservation Form	
//jQueryUI - Datepicker
if (jQuery().datepicker) {
    jQuery('#checkin').datepicker({
        showAnim: "drop",
        dateFormat: "yy/mm/dd",
        minDate: "-0D",
    });

    jQuery('#checkout').datepicker({
        showAnim: "drop",
        dateFormat: "yy/mm/dd",
        minDate: "-0D",
        beforeShow: function () {
            var a = jQuery("#checkin").datepicker('getDate');
            if (a) return {
                minDate: a
            }
        }
    });
    jQuery('#checkin, #checkout').on('focus', function () {
        jQuery(this).blur();
    }); // Remove virtual keyboard on touch devices
}
//Popover
jQuery('[data-toggle="popover"]').popover();